/*
  Multicore Example.c
  
  Launch a function into another cog (processor) and display what it does
  to the global n variable over time. 
  
  http://learn.parallax.com/propeller-c-functions/multicore-example
*/

#include "simpletools.h"                      // Include simpletools

void adder(void *par);                        // Forward declaration
void subtractor(void *par);

static volatile int t, n, m;                     // Global vars for cogs to share

unsigned int stack[44 + 128];                 // Stack vars for other cog
unsigned int stack2[44 +128];

int main()                                    // main function
{
  t = 50;                                     // Set values of t & n
  n = 5000;
  m = 5000;

  // Launch adder function into another cog (processor).
  int cog = cogstart(adder, NULL, stack, sizeof(stack));
  print("cog = %d\n", cog);
  int cogm =cogstart(subtractor,NULL, stack2, sizeof(stack2));
  print("cogm = %d\n", cogm);

  // Watch what the other cog is doing to the value of n.
  while(1)
  {
    print("n = %d\n", n);                     // Display result      
    print("m = %d\n", m); 
    pause(100);                            // Wait 1/10 of a second    
  }    
}

// Function that can continue on its 
// own if launched into another cog.
void adder(void *par)                         // Adder keeps going on its own

{
  while(1)                                    // Endless loop
  {
    n = n + 1;                                // n + 1 each time loop repeats
                                    // Wait for t ms between update   
    pause(t);  
  }
 } 
 void subtractor(void *par)
 {
   while(1)
   
   m = m + 1;
   pause(t);
   
  
}                        

